<template>
  <div class="app">
    <div v-if="isLoading">Loading ......</div>
    <div v-else>
      <div class="container">
        <div class="left-container">
          <table>
            <thead>
              <tr>
                <th>Прізвище</th>
                <th>Ім'я</th>
                <th>Кімната</th>
                <th>Блок</th>
                <th>Номер телефону</th>
                <th>Факультет</th>
                <th>Курс</th>
                <th>Дії</th>
              </tr>
            </thead>
            <tbody>
              <tr
                v-for="item in selectedFaculty ? filteredItems : getItemsList"
                :key="item.id"
              >
                <td>{{ item.lastName }}</td>
                <td>{{ item.name }}</td>
                <td>{{ item.room }}</td>
                <td>{{ item.block }}</td>
                <td>{{ item.phoneNumber }}</td>
                <td>{{ item.faculty }}</td>
                <td>{{ item.course }}</td>
                <td>
                  <button @click="deleteItem(item.id)">Delete</button>
                  <button @click="editItem(item)">Edit</button>
                </td>
              </tr>
            </tbody>
          </table>

        </div>
        <div class="right-container">
          <div class="search-container">
            <hr />
              <label for="filterFaculty">Фільтрувати за факультетом: </label>
               <select v-model="selectedFaculty" id="filterFaculty">
                 <option value="">Всі</option>
                  <option v-for="faculty in uniqueFaculties"
                    :key="faculty"
                    :value="faculty"
                  >
                      {{ faculty }}
                  </option>
               </select> 
         </div>

          <div v-if="editingItem !== null">
            <hr />
             <div class="student-form">
               <div>
                    <label for="editLastName">Прізвище</label>
                    <input v-model="editingItem.lastName" type="text" />
                </div>
                <div>
                    <label for="editLastName">Ім'я</label>
                    <input v-model="editingItem.name" type="text"  />
                </div>
                <div>
                    <label for="editLastName">Кімната</label>
                    <input v-model="editingItem.room" type="text" />
               </div>
                <div>
                    <label for="editLastName">Блок</label>
                    <input v-model="editingItem.block" type="text"  />
                </div>
                <div>
                    <label for="editLastName">Факультет</label>
                    <input v-model="editingItem.faculty" type="text"  />
                </div>
                  <button @click="saveEditedItem">Зберегти зміни</button>
    
                </div>
             </div>
          <hr />
          <div class="student-form">
            <div>
              <label for="lastName">Прізвище</label>
              <input v-model="students.lastName" type="text" id="lastName" />
            </div>
            <div>
              <label for="name">Ім'я</label>
              <input v-model="students.name" type="text" id="name" />
            </div>
            <div>
              <label for="gender">Кімната</label>
              <input v-model="students.room" type="text" id="gender" />
            </div>
            <div>
              <label for="address">Блок</label>
              <input v-model="students.block" type="text" id="address" />
            </div>
            <div>
              <label for="motherNumber">Номер телефону</label>
              <input
                v-model="students.phoneNumber"
                type="text"
                id="motherNumber"
              />
            </div>
            <div>
              <label for="faculty">Факультет</label>
              <input v-model="students.faculty" type="text" id="faculty" />
            </div>
            <div>
              <label for="group">Курс</label>
              <input v-model="students.course" type="text" id="group" />
            </div>
            <button @click="addItem(students)">Додати студента</button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters, mapActions } from "vuex";

export default {
  name: "HomeView",
  data() {
    return {
      students: {},
      selectedFaculty: " ",
      editingItem: null,
    };
  },
  computed: {
    ...mapGetters("students", ["getItemsList", "isLoading"]),
    uniqueFaculties() {
      return [...new Set(this.getItemsList.map((item) => item.faculty))];
    },
    filteredItems() {
      return this.selectedFaculty
        ? this.getItemsList.filter(
            (item) => item.faculty === this.selectedFaculty
          )
        : this.getItemsList;
    },
  },
  created() {
    this.loadList();
  },
  methods: {
    ...mapActions("students", [
      "loadList",
      "addItem",
      "deleteItem",
      "updateItem",
      "loadFilteredData",
    ]),
    
    editItem(item) {
    this.editingItem = item;
  },
  saveEditedItem() {
  const index = this.getItemsList.findIndex(item => item.id === this.editingItem.id);
  this.updateItem(this.editingItem);
  // Directly update the item in the array
  this.getItemsList[index] = { ...this.editingItem };
  this.cancelEdit();
},
  cancelEdit() {
    this.editingItem = null;
  },
    
  },
};
</script>

<style scoped lang="scss">
.app {
  background-image: url("@/assets/L1.png");
  background-size: cover;
  background-position: center;
}

.search-container {
  position: relative;
  margin-top: 20px;
  color: #ccc;
}

.dropdown {
  position: absolute;
  top: 100%;
  left: 0;
  width: 100%;
  background-color: #fff;
  border: 1px solid #ddd;
  max-height: 150px;
  overflow-y: auto;
  box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
  z-index: 1;
}

.dropdown div {
  padding: 10px;
  cursor: pointer;
}

.dropdown div:hover {
  background-color: #f0f0f0;
}
table {
  width: 70%;
  border-collapse: collapse;
  margin-top: 150px;
  margin-left: 40px;
  margin-bottom: 700px;
}

th,
td {
  border: 2px solid #695858;
  padding: 8px;
  text-align: left;
  background-color: #dbd9d9;
}

th {
  background-color: #f2f2f2;
}

button {
  background-color: #6adc3500;
  color: #000000;
  border: none;
  padding: 5px 10px;
  cursor: pointer;
  border-radius: 50px;
}

button:hover {
  background-color: #36c823;
}
.student-form {
  border: 1px solid #000000;
  border-radius: 10px;
  padding: 15px;
  margin: 15px;
  width: 50%;
  margin-left: 140px;
  background-color: #d2cdcd;
}

.student-form div {
  margin-bottom: 10px;
  display: flex;
  flex-direction: line;
  margin: 10px;
}

.student-form label {
  margin-bottom: 3px;
}

.student-form input {
  width: 100%;
  padding: 5px;
  box-sizing: border-box;
  border: 1px solid #ccc;
  border-radius: 50px;
  margin-left: 5px;
}

.student-form button {
  background-color: #4caf50;
  color: white;
  padding: 10px 15px;
  border: none;
  border-radius: 50px;
  cursor: pointer;
}

.student-form button:hover {
  background-color: #45a049;
}
.container {
  display: flex;
}

.left-container {
  flex: 1;
  padding-right: 10px;
}

.right-container {
  flex: 1;
  padding-right: 0px;
}
</style>
